import { DynamicModule, MiddlewareConsumer, NestModule, Type } from '@nestjs/common';
import { HttpAdapterHost, ModuleRef } from '@nestjs/core';
import { ClsModuleAsyncOptions, ClsModuleOptions } from './cls.options';
import { ClsModuleProxyProviderOptions } from './proxy-provider/proxy-provider.interfaces';
export declare class ClsModule implements NestModule {
    private readonly adapterHost;
    private readonly moduleRef;
    constructor(adapterHost: HttpAdapterHost, moduleRef: ModuleRef);
    private static logger;
    configure(consumer: MiddlewareConsumer): void;
    static forRoot(options?: ClsModuleOptions): DynamicModule;
    static forRootAsync(asyncOptions: ClsModuleAsyncOptions): DynamicModule;
    /**
     * Registers the `ClsService` provider in the module
     */
    static forFeature(): DynamicModule;
    static forFeature(...proxyProviderClasses: Array<Type>): DynamicModule;
    static forFeatureAsync(options: ClsModuleProxyProviderOptions): DynamicModule;
    private static createProxyClassProviders;
    private static getProviders;
    private static clsMiddlewareOptionsFactory;
    private static clsGuardOptionsFactory;
    private static clsInterceptorOptionsFactory;
    private static clsGuardFactory;
    private static clsInterceptorFactory;
}
